﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Threading;

namespace ThreadBasics {
	class Program {
		static void Main(string[] args) {
			Console.Write("Main (MTID {0}): Press ENTER to spawn a new thread ...", Thread.CurrentThread.ManagedThreadId);
			Console.ReadLine();

			Thread t = new Thread(YieldingForeverThread);
			t.Start();

			Console.WriteLine("Main (MTID {0}): Run to end, bailing out ...", Thread.CurrentThread.ManagedThreadId);
		}

		static void ForeverThread() {
			Console.WriteLine("ForeverThread (MTID {0}): Starting to spin forever ..", Thread.CurrentThread.ManagedThreadId);
			while (true)
				;
		}

		static void YieldingForeverThread() {
			Console.WriteLine("ForeverThread (MTID {0}): Starting to spin forever ..", Thread.CurrentThread.ManagedThreadId);
			while (true) {
				Thread.Yield();
			}
		}
	}
}
